clang 10.0.0git

Public Member Functions | Static Public Member Functions | List of all members
clang::threadSafety::til::Return Class Reference

Return from the enclosing function, passing the return value to the caller. More...

`#include "clang/Analysis/Analyses/ThreadSafetyTIL.h"`

Inheritance diagram for clang::threadSafety::til::Return:
[legend]
Collaboration diagram for clang::threadSafety::til::Return:
[legend]

## Public Member Functions
| Return (SExpr *Rval)
| Return (const Return &R, SExpr *Rval)
ArrayRef< BasicBlock * > | successors ()
| Return an empty list. More...
SExpr * | returnValue ()
const SExpr * | returnValue () const
template<class V >
V::R_SExpr | traverse (V &Vs, typename V::R_Ctx Ctx)
template<class C >
C::CType | compare (const Return *E, C &Cmp) const
Public Member Functions inherited from clang::threadSafety::til::Terminator
ArrayRef< BasicBlock * > | successors ()
| Return the list of basic blocks that this terminator can branch to. More...
ArrayRef< BasicBlock * > | successors () const
Public Member Functions inherited from clang::threadSafety::til::SExpr
| SExpr ()=delete
TIL_Opcode | opcode () const
void * | operator new (size_t S, MemRegionRef &R)
void * | operator new (size_t)=delete
| SExpr objects must be created in an arena. More...
void | operator delete (void *)=delete
| SExpr objects cannot be deleted. More...
unsigned | id () const
| Returns the instruction ID for this expression. More...
BasicBlock * | block () const
| Returns the block, if this is an instruction in a basic block, otherwise returns null. More...
void | setID (BasicBlock *B, unsigned id)
| Set the basic block and instruction ID for this expression. More...

## Static Public Member Functions
static bool | classof (const SExpr *E)
Static Public Member Functions inherited from clang::threadSafety::til::Terminator
static bool | classof (const SExpr *E)

## Additional Inherited Members
Protected Member Functions inherited from clang::threadSafety::til::Terminator
| Terminator (TIL_Opcode Op)
| Terminator (const SExpr &E)
Protected Member Functions inherited from clang::threadSafety::til::SExpr
| SExpr (TIL_Opcode Op)
| SExpr (const SExpr &E)
Protected Attributes inherited from clang::threadSafety::til::SExpr
const unsigned char | Opcode
unsigned char | Reserved = 0
unsigned short | Flags = 0
unsigned | SExprID = 0
BasicBlock * | Block = nullptr

## Detailed Description

Return from the enclosing function, passing the return value to the caller.

Only the exit block should end with a return statement.

Definition at line 1456 of file ThreadSafetyTIL.h.

## Constructor & Destructor Documentation

## ◆ Return() [1/2]

clang::threadSafety::til::Return::Return | ( | SExpr * | Rval | ) |
| inline

Definition at line 1458 of file ThreadSafetyTIL.h.

## ◆ Return() [2/2]

clang::threadSafety::til::Return::Return | ( | const Return & | R,
|  | SExpr * | Rval
| ) |  |
| inline

Definition at line 1459 of file ThreadSafetyTIL.h.

## Member Function Documentation

## ◆ classof()

static bool clang::threadSafety::til::Return::classof | ( | const SExpr * | E | ) |
| inline static

Definition at line 1461 of file ThreadSafetyTIL.h.

References clang::threadSafety::til::SExpr::opcode().

## ◆ compare()

template<class C >

C::CType clang::threadSafety::til::Return::compare | ( | const Return * | E,
|  | C & | Cmp
| ) |  | const
| inline

Definition at line 1476 of file ThreadSafetyTIL.h.

## ◆ returnValue() [1/2]

SExpr* clang::threadSafety::til::Return::returnValue | ( |  | ) |
| inline

Definition at line 1466 of file ThreadSafetyTIL.h.

Referenced by clang::threadSafety::til::PrettyPrinter< StdPrinter, std::ostream >::printReturn().

## ◆ returnValue() [2/2]

const SExpr* clang::threadSafety::til::Return::returnValue | ( |  | ) | const
| inline

Definition at line 1467 of file ThreadSafetyTIL.h.

## ◆ successors()

ArrayRef<BasicBlock *> clang::threadSafety::til::Return::successors | ( |  | ) |
| inline

Return an empty list.

Definition at line 1464 of file ThreadSafetyTIL.h.

## ◆ traverse()

template<class V >

V::R_SExpr clang::threadSafety::til::Return::traverse | ( | V & | Vs,
|  | typename V::R_Ctx | Ctx
| ) |  |
| inline

Definition at line 1470 of file ThreadSafetyTIL.h.

The documentation for this class was generated from the following file:

- include/clang/Analysis/Analyses/ThreadSafetyTIL.h